#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Event  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
CoordMode, Mouse, Screen

^PgUp::
	retainerGetMaterials()
	ExitApp
return

; End will kill the script entirely
^End::
	ExitApp
return

retainerGetMaterials() {
	ImageSearch, retainerListX, retainerListY, 530, 430, 1260, 1000, *150 images\retainernames.png
	if (ErrorLevel != 0) {
		WriteLog("ImageSearch for retainernames.png returned error level " + ErrorLevel)
		return
	}

	currentRetainer := 2
		
	MouseMove, retainerListX+72, retainerListY+60+((currentRetainer-1)*36), 3
	Sleep 300
	MouseClick ; Click retainer
	MouseClick
	Sleep 2500
	Click 1200, 250 ; Close dialog
	MouseClick
	Sleep 1000

	ImageSearch, entrustWithdrawX, entrustWithdrawY, 940, 512, 1680, 700, *150 images\entrustwithdraw.png
	if (ErrorLevel != 0) {
		WriteLog("ImageSearch for entrustwithdraw.png returned error level " + ErrorLevel)
		return
	}

	MouseMove, entrustWithdrawX+144, entrustWithdrawY+30, 3
	Sleep 300
	MouseClick ; Click entrust/withdraw
	MouseClick
	Sleep 400

	ImageSearch, retainerInventoryX, retainerInventoryY, 1750, 10, 2560, 215, *150 images\retainerinventory.png
	if (ErrorLevel != 0) {
		WriteLog("ImageSearch for retainerinventory.png returned error level " + ErrorLevel)
		return
	}

	; loop through items for this specific retainer

	MouseMove, retainerInventoryX, retainerInventoryY, 3

	; container 1

	; container 2

	; item
	row := 4
	col := 4  ; 69 in between

	MouseMove, retainerInventoryX+404+(col-1)*69, retainerInventoryY+133+(row-1)*69, 3
	Sleep 300
	MouseClick, Right ; 
	Sleep 100
	MouseClick, Right
	Sleep 100


	
	; containers 3-4
	MouseMove, retainerInventoryX+362, retainerInventoryY+68, 3
	Sleep 300
	MouseClick ; Click the 2 button to switch to containers 3-4
	MouseClick


	; item
	row := 4
	col := 4  ; 69 in between

	MouseMove, retainerInventoryX+46+(col-1)*69, retainerInventoryY+133+(row-1)*69, 3
	Sleep 300
	MouseClick, Right ; 
	Sleep 100
	MouseClick, Right
	Sleep 100
	
	; item
	row := 3
	col := 1  ; 69 in between

	MouseMove, retainerInventoryX+46+(col-1)*69, retainerInventoryY+133+(row-1)*69, 3
	Sleep 300
	MouseClick, Right ; 
	Sleep 100
	MouseClick, Right
	Sleep 100

	; item
	row := 3
	col := 4  ; 69 in between

	MouseMove, retainerInventoryX+46+(col-1)*69, retainerInventoryY+133+(row-1)*69, 3
	Sleep 300
	MouseClick, Right ; 
	Sleep 100
	MouseClick, Right
	Sleep 100

	; item
	row := 3
	col := 5  ; 69 in between

	MouseMove, retainerInventoryX+46+(col-1)*69, retainerInventoryY+133+(row-1)*69, 3
	Sleep 300
	MouseClick, Right ; 
	Sleep 100
	MouseClick, Right
	Sleep 100

	; item
	row := 4
	col := 4  ; 69 in between

	MouseMove, retainerInventoryX+46+(col-1)*69, retainerInventoryY+133+(row-1)*69, 3
	Sleep 300
	MouseClick, Right ; 
	Sleep 100
	MouseClick, Right
	Sleep 100

	; item
	row := 5
	col := 3  ; 69 in between

	MouseMove, retainerInventoryX+46+(col-1)*69, retainerInventoryY+133+(row-1)*69, 3
	Sleep 300
	MouseClick, Right ; 
	Sleep 100
	MouseClick, Right
	Sleep 100


	; container 5
	MouseMove, retainerInventoryX+607, retainerInventoryY+68, 3
	Sleep 300
	MouseClick ; Click the 2 button to switch to containers 3-4
	MouseClick
}


example() {
	MouseClick ; Click retainer
	MouseClick

	Sleep 2500
	Click 1200, 250 ; Close dialog
	MouseClick
	Sleep 1000
	ImageSearch, outX, outY, 530, 430, 1660, 900, *150 images\sellitems.png
	if (ErrorLevel = 0) {
		MouseMove, outX+72, outY+20, 2
		Sleep 200
		MouseClick ; Click sellitems
		MouseClick
		Sleep 400

		highestCursorY := 0 ; used to determine if we've reached the bottom of the list

		Loop { ; loop through all items posted for sale
		
			clipboard := "" ; clear the clipboard / pasted price

			Sleep 500
			Send, {Numpad2} ; Move cursor to first/next item
			Sleep 300
			ImageSearch, outX, outY, 2050, 60, 2180, 620, *8 images\selected.png
			if (ErrorLevel = 0) {

				; check if we have hit the bottom of the list and moved back up to the top
				if (outY < highestCursorY-15) { ; -15 to allow for tolerance in image search function
					break 
				}

				; handle case where only 1 item is posted by checking if highlighted item is near expected top of list area and it hasn't moved
				if (outY < 200) && (outY < highestCursorY+15) { ; +15 to allow for tolerance in image search function
					break
				}

				highestCursorY = %outY% ; update highest cursory
				Send, {Numpad0} ; Select the item
				Sleep 100
				Send, {Numpad0} ; Select Adjust Price
				
				
				if (currentRetainer <= numNQRetainers) { ; If it's an HQ retainer, hold shift so penny pincher copies HQ price
					Send, {Shift down}
				}
				Sleep 75
				Send, {Numpad8} ; Move cursor to Compare Prices
				Sleep 85
				Send, {Numpad0} ; Select compare prices
				Sleep 850
				Send, {Esc} ; Close compare prices
				Sleep 200
				if (currentRetainer <= numNQRetainers) { ; If it's an HQ retainer, release shift
					Send, {Shift up}
				}

				if (clipboard = "") { ; If nobody else has listed the item, just keep the same price.  Also stop-gap in case dalamud / penny pincher isn't loaded correctly
					Send, {Esc} ; Close the item
					Sleep 200
					Continue ; Move on to next iteration
				}

				ImageSearch, outX, outY, 1760, 360, 2220, 600, *150 images\askingprice.png
				if (ErrorLevel = 0) {
					MouseMove, outX+300, outY+15, 3
					Sleep 200
					MouseClick ; Click asking price input field
					Sleep 200
					SendRaw %clipboard% ; Update price
					Sleep 175

					Send, {Enter} ; unlock cursor from numerical field
					Sleep 150
					Send, {Numpad2} ; move cursor down to confirm button
					Sleep 150
					Send, {Numpad2}
					Sleep 150
					Send, {Numpad2}
					Sleep 150
					Send, {Numpad0} ; Select confirm button
				}						
			} else {
				break ; there are no items listed for sale
			}
		}

		; Quit retainer
		Send, {Esc} 
		Sleep 200
		Send, {Esc} 
		Sleep 200				
		Send, {Esc} 
		Sleep 200				
		Send, {Esc} 
		Sleep 200
		Send, {Esc} 
		Sleep 1000
		Click 1200, 250 ; Close dialog
		MouseClick
		Sleep 2100

	}
}


WriteLog(text) {
	FileAppend, % A_NowUTC ": " text "`n", logfile.txt ; can provide a full path to write to another directory
}
