package inventorytools

type Inventories struct {
	CharacterBags []Item     `json:"CharacterBags,omitempty"`
	Retainers     []Retainer `json:"Retainers,omitempty"`
	Crystals      []Item     `json:"Crystals,omitempty"`
}

type Item struct {
	ID              int    `json:"iid"`
	Name            string `json:"name,omitempty"`
	SortedContainer int    `json:"sc"`  // container/page 1-5 offset by 9999 for bags and (12000 for market?)
	SortedSlotIndex int    `json:"ssi"` // sorted slot index 0-34
	Quantity        int    `json:"qty"`
}

type Retainer struct {
	ID                int    `json:"id"`
	Name              string `json:"name"`
	MarketItemStorage bool   `json:"marketitemstorage,omitempty"` // true if retainer is used to store items ready for listing on market
	RetainerBags      []Item `json:"RetainerBags,omitempty"`
	RetainerMarket    []Item `json:"RetainerMarket,omitempty"`
}
