#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
#SingleInstance Force
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Event  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
CoordMode, Mouse, Screen
CoordMode, Pixel, Screen

; End will kill the script entirely
^End::
	ExitApp
return

WriteLog(text) {
	FileAppend, % A_NowUTC ": " text "`n", logfile.txt ; can provide a full path to write to another directory
}

WaitImageSearch(ByRef outX, ByRef outY, x1, y1, x2, y2, imageFile, waitFor) {
    sleepTime = 50
    iterations := Floor(waitFor/sleepTime)
    Loop {
        if (A_Index > iterations) 
            break
        ; ImageSearch, outX, outY, x1, y1, x2, y2, imageFile
        ImageSearch, outX, outY, x1, y1, x2, y2, %imageFile%
        err := ErrorLevel
        if (err = 0) {
            return
        }
        Sleep sleepTime
    }
}

selectRetainerMenuItem(retainerMenuX, retainerMenuY, itemNum) {
	; 1 - Entrust or withdraw items.
	; 2 - Entrust or withdraw gil.
	; 3 - Sell items in your inventory on the market.
	; 4 - Sell items in your retainer's inventory on the market.
	; 5 - View sale history.
	; 6 - Assign venture.

	MouseMove, retainerMenuX, retainerMenuY+(itemNum*36), 3
	Sleep 100
	MouseClick
	MouseClick
	MouseClick

}

selectRetainer(ByRef retainerMenuX, ByRef retainerMenuY, retainerNum) {
	WaitImageSearch(retainerListX, retainerListY, 590, 555, 945, 843, "*220 images/retainernames.png", 5000)
	if (!retainerListX||!retainerListY) {
		WriteLog("Could not select retainer, retainer list not found")
		return
	} 
	; initial offset of 58, 22
	; incremental retainer y offset of 36
	MouseMove, retainerListX+58, retainerListY+22+(retainerNum*36), 3
	Sleep 250
	MouseClick ; Click retainer
	MouseClick
	Sleep 2500
	Click 1200, 250 ; Close dialog
	Click 1200, 250 ; Close dialog
	MouseClick

	WaitImageSearch(retainerMenuX, retainerMenuY, 950, 550, 1550, 660, "*150 images/entrustwithdraw.png", 5000)
	if (!retainerMenuX||!retainerMenuY) {
		WriteLog("Retainer selection may have failed, could not validate retainer menu is open!")
		return
	}
	; adjust offsets for first menu item
	retainerMenuX := retainerMenuX+90
	retainerMenuY := retainerMenuY-11

	return
}

exitRetainer() {
	; Quit retainer
	Send, {Esc} 
	Sleep 200
	Send, {Esc} 
	Sleep 200				
	Send, {Esc} 
	Sleep 200				
	Send, {Esc} 
	Sleep 200
	Send, {Esc} 
	Sleep 1000
	Click 1200, 250 ; Close dialog
	MouseClick
}

runXivCommand(command) {
	WaitImageSearch(outX, outY, 530, 430, 1260, 1000, "*150 images/retainernames.png", 3000)
	if (!outX||!outY) {
		WriteLog("skipping command - retainernames.png not detected")
		return
	}

	Send, / 
	Sleep 70 ; it takes a few ms for the chat to activate before we can type
	Send, %command%
	Sleep 100
	Send, {Enter}
}
